
    /*!
    * structured-editor v0.1.5
    * (c) 2019 HollyIT (limited liability)
    * @license MIT
    */
  
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var prosemirrorState = require('prosemirror-state');
var prosemirrorUtils = require('prosemirror-utils');
var structuredEditorExtensions = require('@ledecmf/structured-editor-extensions');
var structuredEditorUi = require('@ledecmf/structured-editor-ui');
var tiptap = require('tiptap');
var prosemirrorModel = require('prosemirror-model');
var Vue = _interopDefault(require('vue'));
var tiptapExtensions = require('tiptap-extensions');
var prosemirrorView = require('prosemirror-view');

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _superPropBase(object, property) {
  while (!Object.prototype.hasOwnProperty.call(object, property)) {
    object = _getPrototypeOf(object);
    if (object === null) break;
  }

  return object;
}

function _get(target, property, receiver) {
  if (typeof Reflect !== "undefined" && Reflect.get) {
    _get = Reflect.get;
  } else {
    _get = function _get(target, property, receiver) {
      var base = _superPropBase(target, property);

      if (!base) return;
      var desc = Object.getOwnPropertyDescriptor(base, property);

      if (desc.get) {
        return desc.get.call(receiver);
      }

      return desc.value;
    };
  }

  return _get(target, property, receiver || target);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

/**
 * @typedef {import('prosemirror-view').EditorView} EditorView
 * @typedef {import('prosemirror-state').EditorState} EditorState
 */

var SelectionEvent =
/*#__PURE__*/
function () {
  /**
   *
   * @param {EditorView} view
   * @param {EditorState} lastState
   */
  function SelectionEvent(view, lastState) {
    _classCallCheck(this, SelectionEvent);

    /**
     * @type {EditorView}
     * @public
     */
    this.view = view;
    this.lastState = lastState;
    this._parentNodes = null;
    this._parentNode = null;
    this._box = null;
  }
  /**
   *
   * @param type
   * @returns {boolean}
   */


  _createClass(SelectionEvent, [{
    key: "in",
    value: function _in(type) {
      return prosemirrorUtils.hasParentNode(function (node) {
        return node.type.name === type;
      })(this.selection);
    }
    /**
     *
     * @returns {Selection<S>}
     */

  }, {
    key: "selection",
    get: function get() {
      return this.view.state.selection;
    }
    /**
     *
     * @returns {*}
     */

  }, {
    key: "node",
    get: function get() {
      return this.selection.node;
    }
    /**
     *
     * @returns {boolean}
     */

  }, {
    key: "empty",
    get: function get() {
      return this.selection.empty;
    }
    /**
     *
     * @returns {EditorState<S>}
     */

  }, {
    key: "state",
    get: function get() {
      return this.view.state;
    }
    /**
     *
     * @returns {Array.<Node>}
     */

  }, {
    key: "parentNodes",
    get: function get() {
      if (this._parentNodes) {
        return this._parentNodes;
      }

      var _this$state$selection = this.state.selection,
          $from = _this$state$selection.$from,
          from = _this$state$selection.from,
          to = _this$state$selection.to;
      this._parentNodes = [];

      for (var i = $from.depth; i > 0; i--) {
        var node = $from.node(i);

        if (node && !this._parentNode) {
          this._parentNode = node;
        }

        this._parentNodes.push(node);
      }

      return this._parentNodes;
    }
    /**
     *
     * @returns {Node}
     */

  }, {
    key: "parentNode",
    get: function get() {
      if (!this._parentNodes) {
        this.parentNodes;
      }

      return this._parentNode;
    }
    /**
     *
     * @returns {string}
     */

  }, {
    key: "type",
    get: function get() {
      if (this.selection instanceof prosemirrorState.TextSelection) {
        return 'text';
      }

      if (this.selection instanceof prosemirrorState.NodeSelection) {
        return 'node';
      }
    }
  }, {
    key: "box",
    get: function get() {
      if (!this._box) {
        var _this$selection = this.selection,
            $from = _this$selection.$from,
            from = _this$selection.from,
            to = _this$selection.to;
        var start = this.view.coordsAtPos(from);
        var end = this.view.coordsAtPos(to);
        this._box = {
          start: start,
          end: end
        };
      }

      return this._box;
    }
  }, {
    key: "parentElement",
    get: function get() {}
  }]);

  return SelectionEvent;
}();

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script = {
  name: 'Editable',
  props: {
    wrapper: {
      type: String,
      default: 'div'
    },
    placeholder: {
      type: String,
      default: ''
    },
    editable: {
      type: Boolean,
      default: true
    },
    value: {},
    textOnly: {
      type: Boolean,
      default: true
    },
    singleLine: {
      type: Boolean,
      default: true
    }
  },
  computed: {
    isEmpty: function isEmpty() {
      return this.value === '';
    }
  },
  data: function data() {
    return {
      input: this.value + ''
    };
  },
  mounted: function mounted() {
    window.addEventListener('click', this.checkMouse);
  },
  beforeDestroy: function beforeDestroy() {
    window.removeEventListener('click', this.checkMouse);
  },
  methods: {
    onPaste: function onPaste(e) {
      e.preventDefault(); // get text representation of clipboard

      var text = (e.originalEvent || e).clipboardData.getData('text/plain');

      if (this.singleLine) {
        text = text.replace(/(\r\n|\n|\r)/gm, ' ');
      } // insert text manually


      document.execCommand("insertHTML", false, text);
    },
    checkMouse: function checkMouse(e) {
      if (!this.$refs.input.contains(e.target)) {
        this.$emit('blur');
      }
    },
    checkKey: function checkKey(e) {
      if (this.singleLine && e.keyCode === 13) {
        e.preventDefault();
        this.$emit('enter');
      }
    },
    doUpdate: function doUpdate() {
      var val = this.textOnly ? this.$refs.input.textContent : this.$refs.input.innerHTML;
      this.$emit('input', val);
    }
  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
/* server only */
, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
  if (typeof shadowMode !== 'boolean') {
    createInjectorSSR = createInjector;
    createInjector = shadowMode;
    shadowMode = false;
  } // Vue.extend constructor export interop.


  var options = typeof script === 'function' ? script.options : script; // render functions

  if (template && template.render) {
    options.render = template.render;
    options.staticRenderFns = template.staticRenderFns;
    options._compiled = true; // functional template

    if (isFunctionalTemplate) {
      options.functional = true;
    }
  } // scopedId


  if (scopeId) {
    options._scopeId = scopeId;
  }

  var hook;

  if (moduleIdentifier) {
    // server build
    hook = function hook(context) {
      // 2.3 injection
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
      // 2.2 with runInNewContext: true

      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__;
      } // inject component styles


      if (style) {
        style.call(this, createInjectorSSR(context));
      } // register component module identifier for async chunk inference


      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    }; // used by ssr in case component is cached and beforeCreate
    // never gets called


    options._ssrRegister = hook;
  } else if (style) {
    hook = shadowMode ? function () {
      style.call(this, createInjectorShadow(this.$root.$options.shadowRoot));
    } : function (context) {
      style.call(this, createInjector(context));
    };
  }

  if (hook) {
    if (options.functional) {
      // register for functional component in vue file
      var originalRender = options.render;

      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      // inject component registration as beforeCreate hook
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }

  return script;
}

var normalizeComponent_1 = normalizeComponent;

/* script */
const __vue_script__ = script;

/* template */
var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c(_vm.wrapper,{ref:"input",tag:"component",staticClass:"lede-editable",class:{'is-empty' : _vm.isEmpty},attrs:{"contenteditable":_vm.editable,"placeholder":_vm.placeholder},domProps:{"textContent":_vm._s(_vm.input)},on:{"focus":function($event){return _vm.$emit('focus')},"input":_vm.doUpdate,"blur":function($event){return _vm.$emit('blur')},"paste":_vm.onPaste,"keydown":_vm.checkKey}})};
var __vue_staticRenderFns__ = [];

  /* style */
  const __vue_inject_styles__ = undefined;
  /* scoped */
  const __vue_scope_id__ = undefined;
  /* module identifier */
  const __vue_module_identifier__ = undefined;
  /* functional template */
  const __vue_is_functional_template__ = false;
  /* style inject */
  
  /* style inject SSR */
  

  
  var Editable = normalizeComponent_1(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    undefined,
    undefined
  );

var ConfigCollection =
/*#__PURE__*/
function () {
  function ConfigCollection(keyProp) {
    _classCallCheck(this, ConfigCollection);

    this._keyProp = keyProp;
    this._items = [];
  }

  _createClass(ConfigCollection, [{
    key: "all",
    value: function all() {
      return this._items;
    }
  }, {
    key: "has",
    value: function has(key) {
      return !!this.get(key);
    }
  }, {
    key: "get",
    value: function get(key) {
      var _this = this;

      return this._items.find(function (item) {
        return item[_this._keyProp] === key;
      });
    }
  }, {
    key: "add",
    value: function add(object) {
      this._items.push(object);

      return this;
    }
  }, {
    key: "getIndex",
    value: function getIndex(key) {
      var _this2 = this;

      this._items.findIndex(function (item) {
        return item[_this2._keyProp] === key;
      });
    }
  }, {
    key: "replace",
    value: function replace(key, object) {
      var idx = this.getIndex(key);

      if (idx > -1) {
        this._items[idx] = object;
        return true;
      } else {
        return false;
      }
    }
  }, {
    key: "remove",
    value: function remove(key) {
      var idx = this.getIndex(key);

      if (idx > -1) {
        this._items.splice(idx, 1);

        return true;
      } else {
        return false;
      }
    }
  }]);

  return ConfigCollection;
}();

var ExtensionCollection =
/*#__PURE__*/
function (_ConfigCollection) {
  _inherits(ExtensionCollection, _ConfigCollection);

  function ExtensionCollection() {
    _classCallCheck(this, ExtensionCollection);

    return _possibleConstructorReturn(this, _getPrototypeOf(ExtensionCollection).call(this, 'name'));
  }

  _createClass(ExtensionCollection, [{
    key: "all",
    value: function all() {
      var _this = this;

      this._items.forEach(function (item) {
        if (item.dependencies) {
          item.dependencies.forEach(function (dep) {
            if (!_this.has(dep.name)) {
              _this.add(dep);
            }
          });
        }
      });

      return this._items;
    }
  }]);

  return ExtensionCollection;
}(ConfigCollection);

/**
 * @property { ConfigCollection } extensions
 * @property {ConfigCollection } plugins
 */

var EditorConfiguration =
/**
 *
 */
function EditorConfiguration() {
  _classCallCheck(this, EditorConfiguration);

  this.extensions = new ExtensionCollection();
  this.extensions.add(new structuredEditorExtensions.Doc()).add(new structuredEditorExtensions.Paragraph()).add(new structuredEditorExtensions.Text());
  this.plugins = new ConfigCollection('name');
  this.selectionMenu = new structuredEditorUi.EditorMenu();
  this.blockMenu = new structuredEditorUi.EditorMenu();
  this.insertMenu = new structuredEditorUi.InsertMenuCollection();
};

var ComponentView =
/*#__PURE__*/
function () {
  function ComponentView(component, _ref) {
    var extension = _ref.extension,
        parent = _ref.parent,
        node = _ref.node,
        view = _ref.view,
        getPos = _ref.getPos,
        decorations = _ref.decorations,
        editable = _ref.editable;

    _classCallCheck(this, ComponentView);

    this.component = component;
    this.extension = extension;
    this.parent = parent;
    this.node = node;
    this.view = view;
    this.getPos = getPos;
    this.decorations = decorations;
    this.editable = editable;
    this.selected = false;
    this.dom = this.createDOM();
    this.contentDOM = this.vm.$refs.content;
  }

  _createClass(ComponentView, [{
    key: "createDOM",
    value: function createDOM() {
      var _this = this;

      var Component = Vue.extend(this.component);
      this.vm = new Component({
        parent: this.parent,
        propsData: {
          node: this.node,
          view: this.view,
          getPos: this.getPos,
          decorations: this.decorations,
          editable: this.editable,
          selected: false,
          options: this.extension.options,
          updateAttrs: function updateAttrs(attrs) {
            return _this.updateAttrs(attrs);
          },
          updateContent: function updateContent(content) {
            return _this.updateContent(content);
          }
        }
      }).$mount();
      return this.vm.$el;
    }
  }, {
    key: "update",
    value: function update(node, decorations) {
      if (node.type !== this.node.type) {
        return false;
      }

      if (node === this.node && this.decorations === decorations) {
        return true;
      }

      this.node = node;
      this.decorations = decorations;
      this.updateComponentProps({
        node: node,
        decorations: decorations
      });
      return true;
    }
  }, {
    key: "updateComponentProps",
    value: function updateComponentProps(props) {
      var _this2 = this;

      if (!this.vm._props) {
        return;
      } // Update props in component
      // TODO: Avoid mutating a prop directly.
      // Maybe there is a better way to do this?


      var originalSilent = Vue.config.silent;
      Vue.config.silent = true;
      Object.entries(props).forEach(function (_ref2) {
        var _ref3 = _slicedToArray(_ref2, 2),
            key = _ref3[0],
            value = _ref3[1];

        _this2.vm._props[key] = value;
      }); // this.vm._props.node = node
      // this.vm._props.decorations = decorations

      Vue.config.silent = originalSilent;
    }
  }, {
    key: "updateAttrs",
    value: function updateAttrs(attrs) {
      if (!this.editable) {
        return;
      }

      var transaction = this.view.state.tr.setNodeMarkup(this.getPos(), null, _objectSpread({}, this.node.attrs, attrs));
      this.view.dispatch(transaction);
    }
  }, {
    key: "updateContent",
    value: function updateContent(content) {
      if (!this.editable) {
        return;
      }

      var transaction = this.view.state.tr.setNodeMarkup(this.getPos(), this.node.type, {
        content: content
      });
      this.view.dispatch(transaction);
    } // prevent a full re-render of the vue component on update
    // we'll handle prop updates in `update()`

  }, {
    key: "ignoreMutation",
    value: function ignoreMutation() {
      return true;
    } // disable (almost) all prosemirror event listener for node views

  }, {
    key: "stopEvent",
    value: function stopEvent(event) {
      if (typeof this.extension.stopEvent === 'function') {
        return this.extension.stopEvent(event, this.vm);
      }

      var isPaste = event.type === 'paste';
      var draggable = !!this.extension.schema.draggable;

      if (draggable || isPaste) {
        return false;
      }

      return true;
    }
  }, {
    key: "selectNode",
    value: function selectNode() {
      this.updateComponentProps({
        selected: true
      });
    }
  }, {
    key: "deselectNode",
    value: function deselectNode() {
      this.updateComponentProps({
        selected: false
      });
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.vm.$destroy();
    }
  }]);

  return ComponentView;
}();

var Editor =
/*#__PURE__*/
function (_BaseEditor) {
  _inherits(Editor, _BaseEditor);

  function Editor() {
    _classCallCheck(this, Editor);

    return _possibleConstructorReturn(this, _getPrototypeOf(Editor).apply(this, arguments));
  }

  _createClass(Editor, [{
    key: "setParentComponent",
    value: function setParentComponent() {
      var component = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      _get(_getPrototypeOf(Editor.prototype), "setParentComponent", this).call(this, component);

      this.$vm = component;
    }
  }, {
    key: "dispatchTransact1ion",
    value: function dispatchTransact1ion(transaction) {
      this.state = this.state.apply(transaction);
      this.view.updateState(this.state);
      this.setActiveNodesAndMarks();

      if (!transaction.docChanged) {
        return;
      }

      this.emitUpdate(transaction);
    }
  }, {
    key: "initNodeViews",
    value: function initNodeViews(_ref) {
      var parent = _ref.parent,
          extensions = _ref.extensions,
          editable = _ref.editable;
      return extensions.filter(function (extension) {
        return ['node', 'mark'].includes(extension.type);
      }).filter(function (extension) {
        return extension.view;
      }).reduce(function (nodeViews, extension) {
        var nodeView = function nodeView(node, view, getPos, decorations) {
          var component = extension.view;
          return new ComponentView(component, {
            extension: extension,
            parent: parent,
            node: node,
            view: view,
            getPos: getPos,
            decorations: decorations,
            editable: editable
          });
        };

        return _objectSpread({}, nodeViews, _defineProperty({}, extension.name, nodeView));
      }, {});
    }
  }, {
    key: "createPlugins",
    value: function createPlugins() {
      var plugins = this.extensions.plugins;

      if (Array.isArray(this.options.plugins)) {
        plugins = plugins.concat(this.options.plugins);
      }

      return plugins;
    }
  }, {
    key: "getHTML",
    value: function getHTML() {
      var div = document.createElement('div');
      var fragment = prosemirrorModel.DOMSerializer.fromSchema(this.schema).serializeFragment(this.state.doc.content);
      div.appendChild(fragment);
      Array.prototype.slice.call(div.getElementsByTagName('remove-me')).forEach(function (item) {
        item.remove(); // or item.parentNode.removeChild(item); for older browsers (Edge-)
      });
      var removeEmpty = ['p', 'blockquote', 'a', 'li', 'ol', 'ul', 'em', 'del', 'strong', 'u'];
      removeEmpty.forEach(function (intent) {
        Array.prototype.slice.call(div.getElementsByTagName(intent)).forEach(function (item) {
          if (item.innerHTML === '') {
            item.remove();
          } // or item.parentNode.removeChild(item); for older browsers (Edge-)

        });
      });
      return div.innerHTML;
    }
  }]);

  return Editor;
}(tiptap.Editor);

var SelectionManager =
/*#__PURE__*/
function () {
  function SelectionManager(vm) {
    _classCallCheck(this, SelectionManager);

    this._vm = vm;
  }

  _createClass(SelectionManager, [{
    key: "update",
    value: function update(view, prevState) {
      var state = view.state;
      if (prevState && prevState.doc.eq(state.doc) && prevState.selection.eq(state.selection)) return;

      this._vm.$emit('selection', new SelectionEvent(view, prevState));
    }
  }]);

  return SelectionManager;
}();

function SelectionManager$1 (vm) {
  return new prosemirrorState.Plugin({
    view: function view() {
      return new SelectionManager(vm);
    },
    props: {
      decorations: function decorations(state) {
        var decorations = [];

        var decorate = function decorate(node, pos) {
          if (node.type.isBlock && node.childCount === 0) {
            decorations.push(prosemirrorView.Decoration.node(pos, pos + node.nodeSize, {
              class: 'empty-node'
            }));
          }
        };

        state.doc.descendants(decorate);
        return prosemirrorView.DecorationSet.create(state.doc, decorations);
      }
    }
  });
}

var script$1 = {
  name: 'StructuredEditor',
  components: {
    InsertMenu: structuredEditorUi.InsertMenu,
    BlockMenu: structuredEditorUi.BlockMenu,
    SelectionMenu: structuredEditorUi.SelectionMenu,
    EditorContent: tiptap.EditorContent,
    MenuBar: structuredEditorUi.MenuBar
  },
  provide: function provide() {
    return {
      '$editor': this
    };
  },
  props: {
    config: {
      type: [Object, EditorConfiguration],
      required: true
    },
    value: {
      type: [String, Object],
      required: true
    },
    menuBar: {
      type: [Boolean, Number, String]
    },
    menuConfig: Object,
    placeholder: String
  },
  computed: {
    showMenu: function showMenu() {
      if (typeof this.menuBar === 'boolean') {
        return this.menuBar;
      }

      if (this.menuBar === 'touch') {
        return "ontouchstart" in document.documentElement;
      }

      var targetWidth = Number(this.menuBar);

      if (targetWidth) {
        return this.screenWidth <= targetWidth;
      }

      return false;
    },
    menuSettings: function menuSettings() {
      var settings = {
        sticky: true,
        placement: 'top',
        offset: 0,
        scrollElement: window
      };

      if (_typeof(this.menuConfig) === 'object') {
        settings = Object.assign(settings, this.menuConfig);
      }

      return settings;
    }
  },
  data: function data() {
    return {
      tiptap: null,
      hasFocus: false,
      screenWidth: null
    };
  },
  mounted: function mounted() {
    this.screenWidth = window.innerWidth;
    window.addEventListener('resize', this.updateSize);

    if (this.placeholder) {
      this.config.extensions.add(new tiptapExtensions.Placeholder({
        emptyClass: 'is-empty',
        emptyNodeText: this.placeholder,
        showOnlyWhenEditable: true
      }));
    }

    this.config.plugins.add(new SelectionManager$1());
    this.createEditor();
  },
  destroyed: function destroyed() {
    window.removeEventListener('resize', this.updateSize);
  },
  methods: {
    updateSize: function updateSize() {
      this.screenWidth = window.innerWidth;
    },
    setValue: function setValue(content) {
      if (this.tiptap) {
        this.tiptap.setContent(content);
      }
    },
    getHTML: function getHTML() {
      return this.tiptap.getHTML();
    },
    getJSON: function getJSON() {
      return this.tiptap.getJSON();
    },
    focus: function focus() {
      if (this.tiptap) {
        this.tiptap.focus();
      }
    },
    createEditor: function createEditor() {
      var _this = this;

      var vm = this;
      this.tiptap = new Editor({
        extensions: this.config.extensions.all(),
        useBuiltInExtensions: false,
        onUpdate: function onUpdate(_ref) {
          var getJSON = _ref.getJSON,
              getHTML = _ref.getHTML;
          vm.$emit('update', _this);
        },
        onInit: function onInit(editor) {
          vm.$nextTick(function () {
            vm.tiptap.registerPlugin(new SelectionManager$1(vm));
            vm.$emit('ready', editor);
          });
        },
        onFocus: function onFocus() {
          vm.hasFocus = true;
          vm.$emit('focus');
        },
        onBlur: function onBlur() {
          vm.hasFocus = false;
          vm.$emit('blur');
        }
      });
      this.setValue(this.value);
    }
  }
};

/* script */
const __vue_script__$1 = script$1;

/* template */
var __vue_render__$1 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"lede-structured-editor",class:{'has-focus' : _vm.hasFocus, 'menu-mode' : _vm.showMenu}},[(_vm.tiptap)?[(_vm.showMenu)?[_c('menu-bar',{attrs:{"config":_vm.config,"editor":_vm.tiptap,"settings":_vm.menuSettings}})]:[_c('selection-menu',{attrs:{"editor":_vm.tiptap,"menu":_vm.config.selectionMenu}}),_vm._v(" "),_c('block-menu',{attrs:{"editor":_vm.tiptap,"menu":_vm.config.blockMenu}}),_vm._v(" "),_c('insert-menu',{attrs:{"editor":_vm.tiptap,"menu":_vm.config.insertMenu}})],_vm._v(" "),_c('editor-content',{attrs:{"editor":_vm.tiptap}})]:_vm._e()],2)};
var __vue_staticRenderFns__$1 = [];

  /* style */
  const __vue_inject_styles__$1 = undefined;
  /* scoped */
  const __vue_scope_id__$1 = "data-v-5433ae64";
  /* module identifier */
  const __vue_module_identifier__$1 = undefined;
  /* functional template */
  const __vue_is_functional_template__$1 = false;
  /* style inject */
  
  /* style inject SSR */
  

  
  var StructuredEditor = normalizeComponent_1(
    { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
    __vue_inject_styles__$1,
    __vue_script__$1,
    __vue_scope_id__$1,
    __vue_is_functional_template__$1,
    __vue_module_identifier__$1,
    undefined,
    undefined
  );

exports.Editable = Editable;
exports.EditorConfiguration = EditorConfiguration;
exports.SelectionEvent = SelectionEvent;
exports.default = StructuredEditor;
